%global qt_module qtwayland
%global __provides_exclude_from ^%{_qt5_archdatadir}/qml/.*\\.so$

Summary: Qt5 - Wayland platform support and QtCompositor module
Name:    qt5-%{qt_module}
Version: 5.15.7
Release: 3%{?dist}
License: LGPLv3
Url:     http://www.qt.io
%global majmin %(echo %{version} | cut -d. -f1-2)
Source0: https://download.qt.io/official_releases/qt/%{majmin}/%{version}/submodules/%{qt_module}-everywhere-opensource-src-%{version}.tar.xz
Patch3000:  0001-Client-Announce-an-output-after-receiving-more-compl.patch
Patch3001:  0002-Fix-issue-with-repeated-window-size-changes.patch
Patch3002:  0003-Client-Connect-drags-being-accepted-to-updating-the-.patch
Patch3003:  0004-Client-Disconnect-registry-listener-on-destruction.patch
Patch3004:  0005-Client-Set-XdgShell-size-hints-before-the-first-comm.patch
Patch3005:  0006-Fix-build.patch
Patch3006:  0007-Fix-remove-listener.patch
Patch3007:  0008-Hook-up-queryKeyboardModifers.patch
Patch3008:  0009-Correctly-detect-if-image-format-is-supported-by-QIm.patch
Patch3009: 0010-Client-Don-t-always-recreate-frame-callbacks.patch
Patch3010:  0011-Client-Always-destroy-frame-callback-in-the-actual-c.patch
Patch3011:  0012-Fix-the-logic-for-decoding-modifiers-map-in-Wayland-.patch
Patch3012:  0013-Wayland-client-use-wl_keyboard-to-determine-active-s.patch
Patch3013:  0014-Client-do-not-empty-clipboard-when-a-new-popup-windo.patch
Patch3014:  0015-Set-preedit-cursor-when-cursor-equals-to-0.patch
Patch3015:  0016-Client-Implement-DataDeviceV3.patch
Patch3016:  0017-Client-Delay-deletion-of-QDrag-object-until-after-we.patch
Patch3017:  0018-Client-Avoid-processing-of-events-when-showing-windo.patch
Patch3018:  0019-Handle-registry_global-out-of-constructor.patch
Patch3019:  0020-Connect-flushRequest-after-forceRoundTrip.patch
Patch3020:  0021-Move-the-wayland-socket-polling-to-a-separate-event-.patch
Patch3021:  0022-Do-not-create-decorations-when-the-shellSurface-is-n.patch
Patch3022:  0023-Fix-crash-if-no-input-method-module-could-be-loaded.patch
Patch3023:  0024-Client-Remove-mWaitingForUpdateDelivery.patch
Patch3024:  0025-Cursor-position-0-should-still-show-the-cursor.patch
Patch3025:  0026-Update-the-preedit-styling-mapping.patch
Patch3026:  0027-client-Simplify-round-trip-behavior.patch
Patch3027:  0028-Client-Fix-opaque-region-setter.patch
Patch3028:  0029-Use-proper-dependencies-in-compile-tests.patch
Patch3029:  0030-client-update-button-state-and-etc-in-pointer_leave.patch
Patch3030:  0031-Revert-Client-Remove-mWaitingForUpdateDelivery.patch
Patch3031:  0032-Fix-race-condition-on-mWaitingForUpdateDelivery.patch
Patch3032:  0033-use-poll-2-when-reading-from-clipboard.patch
Patch3033:  0034-Reduce-memory-leakage.patch
Patch3034:  0035-Fix-build-with-libcxx-missing-array-include.patch
Patch3035:  0036-Only-close-popup-in-the-the-hierchary.patch
Patch3036:  0037-Build-fixes-for-GCC-11.patch
Patch3037:  0038-Check-pointer-for-null-before-use-in-ASSERT.patch
Patch3038:  0039-Use-wl_surface.damage_buffer-on-the-client-side.patch
Patch3039:  0040-Client-clear-focus-on-touch-cancel.patch
Patch3040:  0041-Guard-mResizeDirty-by-the-correctMutex.patch
Patch3041:  0042-client-Synthesize-enter-leave-event-for-popup-in-xdg.patch
Patch3042:  0043-Fix-compile-tests.patch
Patch3043:  0044-Use-CRLF-line-delimiter-for-text-uri-list-data.patch
Patch3044:  0045-Fix-missing-update-when-toggling-client-side-decorat.patch
Patch3045:  0046-Avoid-calling-requestUpdate-from-wrong-thread.patch
Patch3046:  0047-Client-support-high-dpi-mode-for-window-icon.patch
Patch3047:  0048-Call-finishDrag-in-QWaylandDataDevice-dragSourceCanc.patch
Patch3048:  0049-Hold-surface-read-lock-throughout-QWaylandEglWindow-.patch
Patch3049:  0080-Client-set-constraint-adjustments-for-popups-in-xdg.patch
Patch3050: 0100-Keep-toplevel-windows-in-the-top-left-corner-of-the-screen.patch
Patch3051: qtwayland-decoration-support-backports-from-qt6.patch

BuildRequires: make
BuildRequires:  qt5-qtbase-devel >= %{version}, qt5-qtbase-static, qt5-qtbase-private-devel, qt5-qtdeclarative-devel
%{?_qt5:Requires: %{_qt5} = %{_qt5_version}}

BuildRequires:  pkgconfig(xkbcommon), pkgconfig(xcomposite), pkgconfig(xrender)
BuildRequires:  pkgconfig(wayland-scanner), pkgconfig(wayland-server), pkgconfig(wayland-client), pkgconfig(wayland-cursor), pkgconfig(wayland-egl)
BuildRequires:  pkgconfig(egl), pkgconfig(gl), pkgconfig(libudev), pkgconfig(libinput), libXext-devel

%description
%{summary}.

%package devel
Summary: Development files for %{name}
Requires: %{name} = %{version}-%{release}
Requires: qt5-qtbase-devel
%description devel
%{summary}.



%prep
%autosetup -n %{qt_module}-everywhere-src-%{version} -p1



%build
%{qmake_qt5}

%make_build



%install
make install INSTALL_ROOT=%{buildroot}

pushd %{buildroot}%{_qt5_libdir}
for prl_file in libQt5*.prl ; do
  sed -i -e "/^QMAKE_PRL_BUILD_DIR/d" ${prl_file}
  if [ -f "$(basename ${prl_file} .prl).so" ]; then
    rm -fv "$(basename ${prl_file} .prl).la"
    sed -i -e "/^QMAKE_PRL_LIBS/d" ${prl_file}
  fi
done
popd



%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig



%files
%license LICENSE.*
%doc README
%{_qt5_libdir}/libQt5WaylandCompositor.so.5*
%{_qt5_libdir}/libQt5WaylandClient.so.5*
%{_qt5_plugindir}/wayland-decoration-client/
%{_qt5_plugindir}/wayland-graphics-integration-server
%{_qt5_plugindir}/wayland-graphics-integration-client
%{_qt5_plugindir}/wayland-shell-integration
%{_qt5_plugindir}/platforms/libqwayland-egl.so
%{_qt5_plugindir}/platforms/libqwayland-generic.so
%{_qt5_plugindir}/platforms/libqwayland-xcomposite-egl.so
%{_qt5_plugindir}/platforms/libqwayland-xcomposite-glx.so
%{_qt5_qmldir}/QtWayland/

%files devel
%{_qt5_bindir}/qtwaylandscanner
%{_qt5_headerdir}/QtWaylandCompositor/
%{_qt5_headerdir}/QtWaylandClient/
%{_qt5_libdir}/libQt5WaylandCompositor.so
%{_qt5_libdir}/libQt5WaylandClient.so
%{_qt5_libdir}/libQt5WaylandCompositor.prl
%{_qt5_libdir}/libQt5WaylandClient.prl
%{_qt5_libdir}/cmake/Qt5WaylandCompositor/Qt5WaylandCompositorConfig*.cmake
%{_qt5_libdir}/pkgconfig/*.pc
%{_qt5_archdatadir}/mkspecs/modules/*.pri
%{_qt5_libdir}/cmake/Qt5WaylandCompositor/
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_*.cmake
%{_qt5_libdir}/cmake/Qt5WaylandClient/
%{_qt5_examplesdir}/wayland/


%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.15.7-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.15.7-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Dec 8 2022 Zhao Zhen <jeremiazhao@tencent.com> - 5.15.7-1
- initial
